-- 회원기본
CREATE TABLE MEMBERS (
	MNO      INTEGER      NOT NULL COMMENT '회원일련번호', -- 회원일련번호
	EMAIL    VARCHAR(40)  NOT NULL COMMENT '이메일', -- 이메일
	PWD      VARCHAR(100) NOT NULL COMMENT '암호', -- 암호
	MNAME    VARCHAR(50)  NOT NULL COMMENT '이름', -- 이름
	CRE_DATE DATETIME     NOT NULL COMMENT '가입일', -- 가입일
	MOD_DATE DATETIME     NOT NULL COMMENT '마지막암호변경일' -- 마지막암호변경일
)
COMMENT '회원기본';

-- 회원기본
ALTER TABLE MEMBERS
	ADD CONSTRAINT PK_MEMBERS -- 회원기본 기본키
		PRIMARY KEY (
			MNO -- 회원일련번호
		);

-- 회원기본 유니크 인덱스
CREATE UNIQUE INDEX UIX_MEMBERS
	ON MEMBERS ( -- 회원기본
		EMAIL ASC -- 이메일
	);

ALTER TABLE MEMBERS
	MODIFY COLUMN MNO INTEGER NOT NULL AUTO_INCREMENT COMMENT '회원일련번호';
	
INSERT INTO MEMBERS(EMAIL,PWD,MNAME,CRE_DATE,MOD_DATE)
VALUES ('s1@test.com','1111','홍길동',NOW(),NOW());

INSERT INTO MEMBERS(EMAIL,PWD,MNAME,CRE_DATE,MOD_DATE)
VALUES ('s2@test.com','1111','임꺽정',NOW(),NOW());

INSERT INTO MEMBERS(EMAIL,PWD,MNAME,CRE_DATE,MOD_DATE)
VALUES ('s3@test.com','1111','일지매',NOW(),NOW());

INSERT INTO MEMBERS(EMAIL,PWD,MNAME,CRE_DATE,MOD_DATE)
VALUES ('s4@test.com','1111','이몽룡',NOW(),NOW());

INSERT INTO MEMBERS(EMAIL,PWD,MNAME,CRE_DATE,MOD_DATE)
VALUES ('s5@test.com','1111','성춘향',NOW(),NOW());	

SELECT * FROM MEMBERS;